unit GrHilf_U;
//Hilfsroutinen zur Grafikanzeige

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

type
  TGrHilfData = class(TDataModule)
  private
    { Private-Deklarationen }
  public
    procedure XLabel(Bmp:TBitmap;XMin,XMax,Step:Double;Offset:Integer);
    procedure XLabel_Klein(Bmp:TBitmap;XMin,XMax,Step:Double;Offset:Integer);
    procedure YLabel(Bmp:TBitmap;YMin,YMax,Step:Double;Offset:Double);
    procedure YLabel_KLein(Bmp:TBitmap;YMin,YMax,Step:Double;Offset:Double);
    procedure _MoveTo(Bmp:TBitmap; X,Y:Double);
    procedure _LineTo(Bmp:TBitmap; X,Y:Double);
    procedure XGitter(Bmp:TBitmap;XMin,XMax,Step:Double;YMin,YMax:Double);
    procedure YGitter(Bmp:TBitmap;YMin,YMax,Step:Double;XMin,XMax:Double);
    procedure SetAereaLimit(Xa0,Ya0,Xa1,Ya1:Double);
    procedure SetBmpLimit(X0,Y0,X1,Y1:Integer);
    function  X(Rx:Double):Integer;
    function  Y(Yx:Double):Integer;
     { Public-Deklarationen }
  end;

var
  GrHilf: TGrHilfData;
  RXmin,
  RXmax,
  RYmin,
  RYmax : Double;
  BXmin,
  BXmax,
  BYmin,
  BYmax : Integer;

implementation

{$R *.DFM}

procedure TGrHilfData.XLabel(Bmp:TBitmap;XMin,XMax,Step:Double;Offset:Integer);
//X-Achse beschriften von XMin bis XMax Schrittweite Step
//Text: Step+Offset
//Beschriftete Linien werden dick gezeichnet
var
  AltWidth : Integer;
  AltColor : TColor;
  Xt,
  Yt   : Integer;
  Xtmp : Double;

begin
  AltWidth:=Bmp.Canvas.Pen.Width;
  AltColor:=Bmp.Canvas.Pen.Color;
  XTmp:=XMin;
  If XMin>XMax then
    begin
      ShowMessage('XLabel: XMin>XMax'+#10+'Achse kann nicht beschriftet werden!');
      Exit;
    end;
  Bmp.Canvas.Pen.Width:=2;
  Bmp.Canvas.Pen.Color:=clBlack;
  Repeat
    //Hauptlinien zeichenen
    Bmp.Canvas.MoveTo(GrHilf.X(XTmp),GrHilf.Y(RYMin));
    Bmp.Canvas.LineTo(GrHilf.X(XTmp),GrHilf.Y(RYMax));
    Xt:=GrHilf.X(XTmp)-3;
    Yt:=GrHilf.Y(RYMin)+5;
    //Uhrzeit beschriften (0..23)
    Bmp.Canvas.TextOut(Xt,Yt,IntToStr(Integer(Round(XTmp+Offset))Mod 24));
    //Bmp.Canvas.TextOut(Xt,Yt,FloatToStr(XTmp+Offset));
    XTmp:=XTmp+Step;
  Until XTmp>XMax;
  Bmp.Canvas.Pen.Width:=AltWidth;
  Bmp.Canvas.Pen.Color:=AltColor;
end;

procedure TGrHilfData.XLabel_Klein(Bmp:TBitmap;XMin,XMax,Step:Double;Offset:Integer);
//X-Achse beschriften von XMin bis XMax Schrittweite Step
//Text: Step+Offset
//An den Linien wird nichts gendert (siehe XLabel)
var
  AltWidth : Integer;
  AltColor : TColor;
  Xt,
  Yt   : Integer;
  Xtmp : Double;

begin
  AltWidth:=Bmp.Canvas.Pen.Width;
  AltColor:=Bmp.Canvas.Pen.Color;
  XTmp:=XMin;
  If XMin>XMax then
    begin
      ShowMessage('XLabel: XMin>XMax'+#10+'Achse kann nicht beschriftet werden!');
      Exit;
    end;
  Bmp.Canvas.Pen.Width:=2;
  Bmp.Canvas.Pen.Color:=clBlack;
  Repeat
    Xt:=GrHilf.X(XTmp)-3;
    Yt:=GrHilf.Y(RYMin)+5;
    //Uhrzeit beschriften (0..23)
    Bmp.Canvas.TextOut(Xt,Yt,IntToStr(Integer(Round(XTmp+Offset))Mod 24));
    //Bmp.Canvas.TextOut(Xt,Yt,FloatToStr(XTmp+Offset));
    XTmp:=XTmp+Step;
  Until XTmp>XMax;
  Bmp.Canvas.Pen.Width:=AltWidth;
  Bmp.Canvas.Pen.Color:=AltColor;
end;

procedure TGrHilfData.YLabel(Bmp:TBitmap;YMin,YMax,Step:Double;Offset:Double);
//Y-Achse beschriften von YMin bis Ymax Schrittweite Step
//Text: Step+Offset
//Beschriftete Linien werden dick gezeichnet
var
  AltWidth : Integer;
  AltColor : TColor;
  Xt,
  Yt   : Integer;
  Ytmp : Double;

begin
  AltWidth:=Bmp.Canvas.Pen.Width;
  AltColor:=Bmp.Canvas.Pen.Color;
  YTmp:=YMin;
  If YMin>YMax then
    begin
      ShowMessage('YLabel: YMin>YMax'+#10+'Achse kann nicht beschriftet werden!');
      Exit;
    end;
  Bmp.Canvas.Pen.Width:=2;
  Bmp.Canvas.Pen.Color:=clBlack;
  Repeat
    //Hauptlinien zeichenen
    Bmp.Canvas.MoveTo(GrHilf.X(RXMin),GrHilf.Y(YTmp));
    Bmp.Canvas.LineTo(GrHilf.X(RXMax),GrHilf.Y(YTmp));
    Xt:=GrHilf.X(RXMin)-25;
    Yt:=GrHilf.Y(YTmp)-7;
    Bmp.Canvas.TextOut(Xt,Yt,FloatToStr(YTmp+Offset));
    YTmp:=YTmp+Step;
  Until YTmp>YMax;
  Bmp.Canvas.Pen.Width:=AltWidth;
  Bmp.Canvas.Pen.Color:=AltColor;
end;

procedure TGrHilfData.YLabel_KLein(Bmp:TBitmap;YMin,YMax,Step:Double;Offset:Double);
//Y-Achse beschriften von YMin bis Ymax Schrittweite Step
//Text: Step+Offset
//An den Linien wird nichts gendert (siehe YLabel)
var
  AltWidth : Integer;
  AltColor : TColor;
  Xt,
  Yt   : Integer;
  Ytmp : Double;

begin
  AltWidth:=Bmp.Canvas.Pen.Width;
  AltColor:=Bmp.Canvas.Pen.Color;
  YTmp:=YMin;
  If YMin>YMax then
    begin
      ShowMessage('YLabel: YMin>YMax'+#10+'Achse kann nicht beschriftet werden!');
      Exit;
    end;
  Bmp.Canvas.Pen.Width:=2;
  Bmp.Canvas.Pen.Color:=clBlack;
  Repeat
    Xt:=GrHilf.X(RXMin)-25;
    Yt:=GrHilf.Y(YTmp)-7;
    Bmp.Canvas.TextOut(Xt,Yt,FloatToStr(YTmp+Offset));
    YTmp:=YTmp+Step;
  Until YTmp>YMax;
  Bmp.Canvas.Pen.Width:=AltWidth;
  Bmp.Canvas.Pen.Color:=AltColor;
end;


procedure TGrHilfData.XGitter(Bmp:TBitmap;XMin,XMax,Step:Double;YMin,YMax:Double);
//Zeichent senkrechte Gitterlinen von XMin bis XMax mit der Schrittweite Step
var
  X : Double;
  AltColor : TColor;

begin
  AltColor:=Bmp.Canvas.Pen.Color;
  Bmp.Canvas.Pen.Color:=clGray;    //Graue Linien zeichenen
  X:=XMin;
  Repeat
    Bmp.Canvas.MoveTo(GrHilf.X(X),GrHilf.Y(YMin));
    Bmp.Canvas.LineTo(GrHilf.X(X),GrHilf.Y(YMax));
    X:=X+Step;
  Until X>XMax;
  Bmp.Canvas.Pen.Color:=AltColor;
end;

procedure TGrHilfData.YGitter(Bmp:TBitmap;YMin,YMax,Step:Double;XMin,XMax:Double);
//Zeichent waagrechte Gitterlinen von YMin bis YMax mit der Schrittweite Step
var
  AltPen:TPen;
  Y : Double;
  AltColor : TColor;

begin
  AltPen:=Bmp.Canvas.Pen;
  Bmp.Canvas.Pen.Color:=clGray;    //Graue Linien zeichenen
  Y:=YMin;
  Repeat
    Bmp.Canvas.MoveTo(GrHilf.X(XMin),GrHilf.Y(Y));
    Bmp.Canvas.LineTo(GrHilf.X(XMax),GrHilf.Y(Y));
    Y:=Y+Step;
  Until Y>YMax;
  Bmp.Canvas.Pen:=AltPen;
end;


procedure TGrHilfData.SetAereaLimit(Xa0,Ya0,Xa1,Ya1:Double);
//Dies ist der Auschnitt aus den 'Weltkoordinaten',
//der dargestellt werden soll
begin
  RXmin:=Xa0;
  RYmin:=Ya0;
  RXmax:=Xa1;
  RYmax:=Ya1;
  If Abs(RXmax-RXmin)<1e-10 then
    begin
      RXmax:=RXmin+1e-10; //Division durch 0 verhindern
    end;
  If Abs(RYmax-RYmin)<1e-10 then
    begin
      RYmax:=RYmin+1e-10; //Division durch 0 verhindern
    end;
end;

procedure TGrHilfData.SetBmpLimit(X0,Y0,X1,Y1:Integer);
//In dieses Fenster (Bitmap) werden die 'Mewerte' eingepasst
begin
  BXmin:=X0;
  BXmax:=X1;
  BYmin:=Y0;
  BYmax:=Y1;
  If BXmax<BXmin then
    begin
      ShowMessage('Fehler in SetBmpLimit'+#10+'Bitmap: X1 ist kleiner X0');
      BXmax:=BXmin+1;
    end;
  If BYmax<BYmin then
    begin
      ShowMessage('Fehler in SetBmpLimit'+#10+'Bitmap: Y1 ist kleiner Y0');
      BYmax:=BYmin+1;
    end;
  If BXmax=BXmin then //Division / 0 verhindern
    begin
      ShowMessage('Fehler in SetBmpLimit'+#10+'Bitmap: X0 = X1');
      BXmax:=BXmin+1;
    end;
  If BYmax=BYmin then //Division / 0 verhindern
    begin
      ShowMessage('Fehler in SetBmpLimit'+#10+'Bitmap: Y0 = Y1');
      BYmax:=BYmin+1;
    end;
end;

function TGrHilfData.X(Rx:Double):Integer;
//Ermittelt aus der 'Weltkoordinate' (Double)
//die Bitmapkoordinate

var
  F1 : Double;

begin
  F1:=(Rx-Rxmin)/(Rxmax-Rxmin);
  Result:=Round(F1*(BXmax-BXmin)+BXmin);
end;

function TGrHilfData.Y(Yx:Double):Integer;
//Ermittelt aus der 'Weltkoordinate' (Double)
//die Bitmapkoordinate

var
  F1 : Double;

begin
  F1:=(RYmax-Yx)/(RYmax-RYmin);
  Result:=Round(F1*(BYmax-BYmin)+BYmin);
end;

procedure TGrHilfData._MoveTo(Bmp:TBitmap; X,Y:Double);
//X,Y in 'Weltkoordinaten' (Double) werden in Bitmap eingepasst
begin
  Bmp.Canvas.MoveTo(GrHilf.X(X),GrHilf.Y(Y));
end;

procedure TGrHilfData._LineTo(Bmp:TBitmap; X,Y:Double);
//X,Y in 'Weltkoordinaten' (Double) werden in Bitmap eingepasst
begin
  Bmp.Canvas.LineTo(GrHilf.X(X),GrHilf.Y(Y));
end;

end.

